<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('名称')" prop="name">
        <el-input
          v-model="queryParams.name"
          :placeholder="$t('请输入') + $t('名称')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('中文名称')" prop="cname">
        <el-input
          v-model="queryParams.cname"
          :placeholder="$t('请输入') + $t('中文名称')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('组织机构代码')" prop="deptCode">
        <el-input
          v-model="queryParams.deptCode"
          :placeholder="$t('请输入') + $t('组织机构代码')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('类型')" prop="pType">
        <el-select v-model="queryParams.pType" :placeholder="$t('请选择') + $t('类型')" clearable size="small">
          <el-option
            v-for="dict in pTypeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
	    <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">{{ $t('搜索') }}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{ $t('重置') }}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:plant:add']"
        >{{ $t('新增') }}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="plantList"
      row-key="plantId"
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <el-table-column :label="$t('名称')" align="center" prop="name" />
      <el-table-column :label="$t('类型')" align="center" prop="pType" >
        <template slot-scope="scope">
          <el-tag v-if="scope.row.pType == '1'" size="small" type="success">{{$t('装置')}}</el-tag>
          <el-tag v-else-if="scope.row.pType == '2'" size="small" type="info">{{$t('单元')}}</el-tag>
        </template>
      </el-table-column>
      <el-table-column :label="$t('中文名称')" align="center" prop="cname" />
      <el-table-column :label="$t('组织机构代码')" align="center" prop="deptCode" />
      <el-table-column :label="$t('备注')" align="center" prop="remarks" />
      <el-table-column :label="$t('排序')" align="center" width="50" prop="orderNum" />
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:plant:edit']"
          >{{ $t('修改') }}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:plant:remove']"
          >{{ $t('删除') }}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改装置管理对话框 -->
    <el-dialog v-dialogDrag :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('父类')" prop="parentId">
          <treeselect v-model="form.parentId" :options="plantOptions" :normalizer="normalizer" :placeholder="$t('请选择') + $t('父类')" />
        </el-form-item>
        <el-form-item :label="$t('名称')" prop="name">
          <el-input v-model="form.name" :placeholder="$t('请输入') + $t('名称')" />
        </el-form-item>
        <el-form-item :label="$t('排序')" prop="orderNum">
          <el-input v-model="form.orderNum" :placeholder="$t('请输入') + $t('排序')" />
        </el-form-item>
        <el-form-item :label="$t('中文名称')" prop="cname">
          <el-input v-model="form.cname" :placeholder="$t('请输入') + $t('中文名称')" />
        </el-form-item>
        <el-form-item :label="$t('组织机构代码')" prop="deptCode">
          <el-input v-model="form.deptCode" :placeholder="$t('请输入') + $t('组织机构代码')" />
        </el-form-item>
        <el-form-item :label="$t('备注')" prop="remarks">
          <el-input v-model="form.remarks" type="textarea" :placeholder="$t('请输入') + $t('内容')" />
        </el-form-item>
        <el-form-item :label="$t('类型')">
          <el-radio-group v-model="form.pType">
            <el-radio
              v-for="dict in pTypeOptions"
              :key="dict.dictValue"
              :label="parseInt(dict.dictValue)"
            >{{dict.dictLabel}}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listPlant, getPlant, delPlant, addPlant, updatePlant, exportPlant } from "@/api/system/plant";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "Plant",
  components: {
    Treeselect
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: false,
      // 装置管理表格数据
      plantList: [],
      // 装置管理树选项
      plantOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 类型字典
      pTypeOptions: [],
      // 查询参数
      queryParams: {
        name: null,
        cname: null,
        deptCode: null,
        pType: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_plant_type").then(response => {
      this.pTypeOptions = response.data;
    });
  },
  methods: {
    /** 查询装置管理列表 */
    getList() {
      this.loading = true;
      listPlant(this.queryParams).then(response => {
        this.plantList = this.handleTree(response.data, "plantId", "parentId");
        this.loading = false;
      });
    },
    /** 转换装置管理数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.plantId,
        label: node.name,
        children: node.children
      };
    },
	/** 查询部门下拉树结构 */
    getTreeselect() {
      listPlant().then(response => {
        this.plantOptions = [];
        const data = { plantId: 0, name: this.$t('顶级节点'), children: [] };
        data.children = this.handleTree(response.data, "plantId", "parentId");
        this.plantOptions.push(data);
      });
    },
    // 类型字典翻译
    pTypeFormat(row, column) {
      return this.selectDictLabel(this.pTypeOptions, row.pType);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        plantId: null,
        parentId: null,
        name: null,
        orderNum: null,
        delFlag: null,
        cname: null,
        deptCode: null,
        remarks: null,
        pType: 0
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
	  this.getTreeselect();
      this.open = true;
      this.title = this.$t('添加')+this.$t('装置管理');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
	  this.getTreeselect();
      if (row != null) {
        this.form.parentId = row.plantId;
      }
      getPlant(row.plantId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('修改')+this.$t('装置管理') ;
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.plantId != null) {
            updatePlant(this.form).then(response => {
              this.msgSuccess(this.$t('修改成功'));
              this.open = false;
              this.getList();
            });
          } else {
            addPlant(this.form).then(response => {
              this.msgSuccess(this.$t('新增成功'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$confirm(this.$t('是否确认删除装置管理编号为"')+' '+row.plantId+this.$t('"的数据?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return delPlant(row.plantId);
        }).then(() => {
          this.getList();
          this.msgSuccess(this.$t('删除成功'));
        })
    }
  }
};
</script>
